/*
 * GXMame
 *
 * 2002, Stphane Pontier <shadow_walker@users.sourceforge.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "gxmame.h"
#include "mameio.h"
#include "progression_window.h"
#include "io.h"
#include "gui.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#define BUFFER_SIZE 1000



gboolean create_game_list_file(void)
{
	FILE *xmame_pipe=NULL;
	FILE *gamelistfile=NULL;
	gchar *filename;
	gchar line[BUFFER_SIZE];

	gchar *romname = NULL;
	gchar *gamename = NULL;
	gchar *gamenameext = NULL;
	gchar *year = NULL;
	gchar *manu = NULL;
	gchar *cloneof = NULL;
	gchar *romof = NULL;
	gchar *sampleof = NULL;
	gchar *input = NULL;
	gchar *video = NULL;
	gchar *channels = NULL;
	gchar *chip[16];
	gchar *driver_status = NULL;
	gchar *control = NULL;
	gchar *cpu1 = NULL;
	gchar *cpu2 = NULL;
	gchar *cpu3 = NULL;
	gchar *cpu4 = NULL;
	gchar *cpu1_clock = NULL;
	gchar *cpu2_clock = NULL;
	gchar *cpu3_clock = NULL;
	gchar *cpu4_clock = NULL;
	gchar *sound1 = NULL;
	gchar *sound2 = NULL;
	gchar *sound3 = NULL;
	gchar *sound4 = NULL;
	gchar *sound1_clock = NULL;
	gchar *sound2_clock = NULL;
	gchar *sound3_clock = NULL;
	gchar *sound4_clock = NULL;
	gchar *num_players = NULL;
	gchar *num_buttons = NULL;
	gint nb_roms;
	gint nb_samples;
	gboolean the_trailer;
	
	gchar *driver = NULL;
	gchar *status = NULL;

	gchar *p = NULL, *p2 = NULL;
	gchar *keyword = NULL;
	gchar *value = NULL;
	gchar **tmp_array;

        gchar *opt;

	gint i = 0;
	gint tmp_counter = 0;
	gint done_roms = 0;
	gfloat done;

	GHashTable *driver_htable=NULL;
	gchar *driverkey,*drivervalue;
	gchar *driverkey2,*drivervalue2;
	
	GtkWidget *progress_window;
	
	romname = g_malloc0(MAX_ROMNAME);
	gamename = g_malloc0(MAX_GAMENAME);
	gamenameext = g_malloc0(MAX_GAMENAME);
	year = g_malloc0(MAX_YEAR);
	manu = g_malloc0(MAX_MANU);
	cloneof = g_malloc0(MAX_ROMNAME);
	romof = g_malloc0(MAX_ROMNAME);
	sampleof = g_malloc0(MAX_ROMNAME);
	input = g_malloc0(200);
	status = g_malloc0(200);
	channels = g_malloc0(200);
	driver = g_malloc0(MAX_ROMNAME);

	cpu1 = g_malloc0(MAX_CPU);
	cpu2 = g_malloc0(MAX_CPU);
	cpu3 = g_malloc0(MAX_CPU);
	cpu4 = g_malloc0(MAX_CPU);
	cpu1_clock = g_malloc0(MAX_CPU);
	cpu2_clock = g_malloc0(MAX_CPU);
	cpu3_clock = g_malloc0(MAX_CPU);
	cpu4_clock = g_malloc0(MAX_CPU);
	sound1 = g_malloc0(MAX_CPU);
	sound2 = g_malloc0(MAX_CPU);
	sound3 = g_malloc0(MAX_CPU);
	sound4 = g_malloc0(MAX_CPU);
	sound1_clock = g_malloc0(MAX_CPU);
	sound2_clock = g_malloc0(MAX_CPU);
	sound3_clock = g_malloc0(MAX_CPU);
	sound4_clock = g_malloc0(MAX_CPU);
	control = g_malloc0(MAX_CONTROL);
	num_players = g_malloc0(MAX_ROMNAME);
	num_buttons = g_malloc0(MAX_ROMNAME);
	
	for (tmp_counter = 0; tmp_counter < 16; tmp_counter++) {
		chip[tmp_counter] = NULL;
	}
	driver_status = g_malloc0(200);
	video = g_malloc0(200);

	/* display the grogression window */
	progress_window = create_loading_progress_window(FALSE);
	gtk_window_set_title(GTK_WINDOW(progress_window),_("Creating game list..."));
	gtk_widget_show(progress_window);
	update_loading_progress_window(0,_("receiving data, please wait"));
	while (gtk_events_pending()) gtk_main_iteration();
	
	get_mame_version(GAMELIST);
	
	/* Generate the table for drivers */
	/* without including neither history nor mameinfo to have less to parse after*/
        opt=g_strdup_printf("%s -listsourcefile 2>/dev/null",mame_executable); 
        xmame_pipe = popen(opt, "r");
        g_free(opt);

	driver_htable = g_hash_table_new (g_str_hash, g_str_equal);
	
	/*FIXME why the hell there is a delay when we reach the end of this loop???*/
	while (fgets(line, BUFFER_SIZE, xmame_pipe))
	{
		driverkey = p = p2 = line;
		for(i = 0;(*p && (*p != '/') && (*p != ':') && (*p != '\n'));i++,p++);
		/* we should got the total supported games*/
		if (*p == '/')
		{
			for(p2++;(*p2 && (*p2++ != ' ')););
			*p2 = '\0';
			for(p++;(*p && (*p++ != '/')););
			drivervalue = p;
			for(i=0,p++;(*p && (*p != '.') && (*p != '\n'));i++,p++);
			*p = '\0';

			if (i > 0)
			{
				/* need to remove the null character otherwise, the g_str_equal does work 
				   at the next stage */
				driverkey2=g_strndup(driverkey,strlen(driverkey)-1);
				drivervalue2=g_strdup(drivervalue);
				g_hash_table_insert(driver_htable,driverkey2,drivervalue2);
			}
			
		} else if (*p == ':')
		{
			p[0]='\0';
			if (!strcmp(driverkey,"Total Supported"))
			{
				p = p+2;
				for(drivervalue = p;(*p && (*p != '\n'));p++);
				*p = '\0';
				supported_games = atoi(drivervalue);
				gxmame_debug("total games supported=:%d",supported_games);
			}
		}
	/* need to update here otherwise, the progress window stay blanc until 
	   we exit this loop */
	while (gtk_events_pending()) gtk_main_iteration();
	}
	gxmame_debug("drivers list loaded");
	g_message(_("creating game list, Please wait:"));
	pclose(xmame_pipe);
	g_snprintf(line,BUFFER_SIZE ,_("Creating game list(%d games)..."), supported_games);
	gtk_window_set_title(GTK_WINDOW(progress_window),line);
	while (gtk_events_pending()) gtk_main_iteration();
		
	/* Generate the list */
	/* without including neither history nor mameinfo to have less to parse after*/
        opt=g_strdup_printf("%s -listinfo -historyfile /dev/null -mameinfofile /dev/null 2>/dev/null",mame_executable); 
        xmame_pipe = popen(opt, "r");
        g_free(opt);
	
	filename = g_malloc(50);
	g_snprintf(filename, 50, "%s/.gxmame/gamelist", getenv("HOME"));

	if ((gamelistfile = fopen(filename, "w")) == NULL) {
		g_free(filename);
		return (FALSE);
	}

	fputs("# GXMame 0.7",gamelistfile);
	fputs("\n# Name ",gamelistfile);
	fputs(list_version.name,gamelistfile);
	fputs("\n# Target ",gamelistfile);
	fputs(list_version.target,gamelistfile);
	fputs("\n# Version ",gamelistfile);
	fputs(list_version.version,gamelistfile);
fputs("\n# list of xmame games for GXMame front-end
# The fileformat is: romnamegamenamegamenameextthe_traileryearmanufacturercloneofromofdriverstatuscolorscpu1cpu1_clockcpu2cpu2_clockcpu3cpu3_clockcpu4cpu4_clocksound1sound1_clocksound2sound2_clocksound3sound3_clocksound4sound4_clocknum_playersnum_buttonscontrolvectorscreen_xscreen_yscreen_freqhorizontalchannelsnb_romsnb_samplessampleof\n",
		gamelistfile);

	while (fgets(line, BUFFER_SIZE, xmame_pipe))
	{
		line[strlen(line) - 1] = 0;
		nb_roms = 0;
		/*the game begin here*/
		if (!strcmp(line, "game (")) {
			g_snprintf(romname, MAX_ROMNAME, "Unknown");
			g_snprintf(gamename, MAX_GAMENAME, "Unknown");
			g_snprintf(gamenameext, MAX_GAMENAME, "Unknown");
			g_snprintf(year, MAX_YEAR, "-");
			g_snprintf(manu, MAX_MANU, "Unknown");
			g_snprintf(cloneof, MAX_ROMNAME, "-");
			g_snprintf(romof, MAX_ROMNAME, "-");
			g_snprintf(sampleof, MAX_ROMNAME, "-");
			nb_samples = 0;
			the_trailer=FALSE;
			while (fgets(line, BUFFER_SIZE, xmame_pipe)) {
				/* the game ends here */
				if (line[0] == ')')
					break;
				/* find the keyword separated by a space */
				for (i=0,keyword = p = line + 1;(*p && (*p++ != ' '));i++);

				keyword[i] = '\0';

				if (p[0] == '\"')
					*p = *p++;

				for (i=0, value = p;(*p && (*p++ != '\n'));i++);

				if (value[i - 1] == '\"')
					i--;
				value[i] = '\0';

				if (!strcmp(keyword, "name"))
					g_snprintf(romname, MAX_ROMNAME, value);
				else if (!strcmp(keyword, "description"))
				{
					if (!g_strncasecmp(value,"The ",4))
					{
						value = value+4;
						the_trailer=TRUE;
					}
					for (i=0,p=value;(*p && (*p != '/') && (*p++ != '('));i++);
					if (*p=='/')
					{	/*Fix for F/A (Japan)*/
						if (value[i-1]=='F')
						{
							value[i+2] = '\0';
							p = p+3;
						}
						else
							value[i-1] = '\0';
						g_snprintf(gamenameext, MAX_GAMENAME, p);
//						printf("%s separator / and %s\n",value,p);
					}
					else if(*--p=='(')
					{
						value[i-1] = '\0';
						g_snprintf(gamenameext, MAX_GAMENAME, p);
//						printf("%s separator ( and %s\n",value,p);
					}
					g_snprintf(gamename, MAX_GAMENAME, value);
				}
				else if (!strcmp(keyword, "year"))
					g_snprintf(year, MAX_YEAR, value);
				else if (!strcmp(keyword, "manufacturer"))
					g_snprintf(manu, MAX_MANU, value);
				else if (!strcmp(keyword, "rom"))
					nb_roms++;
				else if (!strcmp(keyword, "sample"))
					nb_samples++;
				else if (!strcmp(keyword, "cloneof"))
					g_snprintf(cloneof, MAX_ROMNAME, value);
				else if (!strcmp(keyword, "romof"))
					g_snprintf(romof, MAX_ROMNAME, value);
				else if (!strcmp(keyword, "sampleof"))
					g_snprintf(sampleof, MAX_ROMNAME, value);
				else if (!strcmp(keyword, "chip")) {
					tmp_counter = 0;
					/* Put it in the next free chip[] slot */
					while ((chip[tmp_counter] != NULL)
					       && tmp_counter < 16)
						tmp_counter++;
					if ((chip[tmp_counter] == NULL))
						chip[tmp_counter] = g_strdup(value);
				}
				else if (!strcmp(keyword, "video"))
					g_snprintf(video, 200, value);
				else if (!strcmp(keyword, "input"))
					g_snprintf(input, 200, value);
				else if (!strcmp(keyword, "driver"))
					g_snprintf(driver_status, 200, value);
				else if (!strcmp(keyword, "sound"))
				{
					tmp_array = g_strsplit(value, " ",3);
					if (!strcmp(tmp_array[1], "channels"))
						g_snprintf(channels,200,tmp_array[2]);
					g_strfreev(tmp_array);
				}

			}

			
			/*write directly in the file*/
			fputs(romname, gamelistfile);
			fputs("", gamelistfile);
			fputs(gamename, gamelistfile);
			fputs("", gamelistfile);
			if(strcmp(gamenameext,"Unknown"))
				fputs(gamenameext, gamelistfile);
			if (the_trailer)
				fputs("true", gamelistfile);
			else
				fputs("false", gamelistfile);
			fputs(year, gamelistfile);
			fputs("", gamelistfile);
			fputs(manu, gamelistfile);
			fputs("", gamelistfile);
			fputs(cloneof, gamelistfile);
			fputs("", gamelistfile);
			fputs(romof, gamelistfile);
			fputs("", gamelistfile);

			/* the driver name already obtained before */
			drivervalue = g_hash_table_lookup (driver_htable,romname);
			fputs(drivervalue, gamelistfile);
			
			/* now the status driver, 
			   true when good false when preliminary
			   (is there any other option?)
			   
			   status *** color *** sound *** palettesize *** blit *** */
			tmp_array =
			    g_strsplit(driver_status, " ", 10);
			if ((tmp_array[2]) && !strcmp(tmp_array[2], "good"))
			{
				fputs("true", gamelistfile);
			} else {
				fputs("false", gamelistfile);
			}
			fputs(tmp_array[8],gamelistfile);
			fputs("",gamelistfile);
			g_strfreev(tmp_array);

			/* find the chip name and type (CPU or Sound) 
			type *** name *** clock *** ) */
			g_snprintf(cpu1, MAX_ROMNAME, "-");
			g_snprintf(cpu2, MAX_ROMNAME, "-");
			g_snprintf(cpu3, MAX_ROMNAME, "-");
			g_snprintf(cpu4, MAX_ROMNAME, "-");
			g_snprintf(sound1, MAX_ROMNAME, "-");
			g_snprintf(sound2, MAX_ROMNAME, "-");
			g_snprintf(sound3, MAX_ROMNAME, "-");
			g_snprintf(sound4, MAX_ROMNAME, "-");
			g_snprintf(control, MAX_CONTROL, "-");
			g_snprintf(cpu1_clock, MAX_ROMNAME, "-");
			g_snprintf(cpu2_clock, MAX_ROMNAME, "-");
			g_snprintf(cpu3_clock, MAX_ROMNAME, "-");
			g_snprintf(cpu4_clock, MAX_ROMNAME, "-");
			g_snprintf(sound1_clock, MAX_ROMNAME, "-");
			g_snprintf(sound2_clock, MAX_ROMNAME, "-");
			g_snprintf(sound3_clock, MAX_ROMNAME, "-");
			g_snprintf(sound4_clock, MAX_ROMNAME, "-");
			
			tmp_counter = 0;
			while ((chip[tmp_counter] != NULL)
			       && (tmp_counter < 16)) {
				tmp_array =
				    g_strsplit(chip[tmp_counter], " ",0);
				/* pure cpu*/
				if (!strcmp(tmp_array[2], "cpu")) {
					if (!strcmp(tmp_array[3], "name")) {
						if (!strcmp(cpu1, "-"))
						{
							g_snprintf(cpu1,
								   MAX_CPU,"%s",
								   tmp_array[4]);
							g_snprintf(cpu1_clock,
								   MAX_CPU,"%s",
								   tmp_array[6]);
						}
						else if (!strcmp(cpu2, "-"))
						{
							g_snprintf(cpu2,
								   MAX_CPU,"%s",
								   tmp_array[4]);
							g_snprintf(cpu2_clock,
								   MAX_CPU,"%s",
								   tmp_array[6]);
						}
						else if (!strcmp(cpu3, "-"))
						{
							g_snprintf(cpu3,
								   MAX_CPU,"%s",
								   tmp_array[4]);
							g_snprintf(cpu3_clock,
								   MAX_CPU,"%s",
								   tmp_array[6]);
						}
						else if (!strcmp(cpu4, "-"))
						{
							g_snprintf(cpu4,
								   MAX_CPU,"%s",
								   tmp_array[4]);
							g_snprintf(cpu4_clock,
								   MAX_CPU,"%s",
								   tmp_array[6]);
						}
					}
					else if (!strcmp(tmp_array[3], "flags"))
					{
						if (!strcmp(cpu1, "-"))
						{
							g_snprintf(cpu1,
								   MAX_CPU,"(sound)%s",
								   tmp_array[6]);
							g_snprintf(cpu1_clock,
								   MAX_CPU,"%s",
								   tmp_array[8]);
						}
						else if (!strcmp(cpu2, "-"))
						{
							g_snprintf(cpu2,
								   MAX_CPU,"(sound)%s",
								   tmp_array[6]);
							g_snprintf(cpu2_clock,
								   MAX_CPU,"%s",
								   tmp_array[8]);
						}
						else if (!strcmp(cpu3, "-"))
						{
							g_snprintf(cpu3,
								   MAX_CPU,"(sound)%s",
								   tmp_array[6]);
							g_snprintf(cpu3_clock,
								   MAX_CPU,"%s",
								   tmp_array[8]);
						}
						else if (!strcmp(cpu4, "-"))
						{
							g_snprintf(cpu4,
								   MAX_CPU,"(sound)%s",
								   tmp_array[6]);
							g_snprintf(cpu4_clock,
								   MAX_CPU,"%s",
								   tmp_array[8]);
						}
					}
				}
			       	else if (!strcmp(tmp_array[2], "audio")) {
					if (!strcmp(sound1, "-"))
					{
						g_snprintf(sound1,
							   MAX_CPU,"%s",
							   tmp_array[4]);
						if (!strcmp(tmp_array[5], "clock"))
						 	g_snprintf(sound1_clock,
								MAX_CPU,"%s",
								tmp_array[6]);
					}
					else if (!strcmp(sound2,"-"))
					{
						g_snprintf(sound2,
							   MAX_CPU,"%s",
							   tmp_array[4]);
						if (!strcmp(tmp_array[5], "clock"))
							g_snprintf(sound2_clock,
							   	MAX_CPU,"%s",
							   	tmp_array[6]);
					}
					else if (!strcmp(sound3,"-"))
					{
						g_snprintf(sound3,
							   MAX_CPU,"%s",
							   tmp_array[4]);
						if (!strcmp(tmp_array[5], "clock"))
							g_snprintf(sound3_clock,
							   	MAX_CPU,"%s",
							   	tmp_array[6]);
					}
					else if (!strcmp(sound4,"-"))
					{
						g_snprintf(sound4,
							   MAX_CPU,"%s",
							   tmp_array[4]);
						if (!strcmp(tmp_array[5], "clock"))
							g_snprintf(sound4_clock,
							  	MAX_CPU,"%s",
							   	tmp_array[6]);
					}
				}

				g_strfreev(tmp_array);
				tmp_counter++;
			}

			tmp_counter = 0;
			while ((chip[tmp_counter] != NULL)) {
				g_free(chip[tmp_counter]);
				chip[tmp_counter] = NULL;
				tmp_counter++;
			}
			/* write these value in good order in the file */
			if (cpu1)
				fputs(cpu1, gamelistfile);
			fputs("", gamelistfile);
			if (cpu1_clock)
				fputs(cpu1_clock, gamelistfile);
			fputs("", gamelistfile);
			if (cpu2)
				fputs(cpu2, gamelistfile);
			fputs("", gamelistfile);
			if (cpu2_clock)
				fputs(cpu2_clock, gamelistfile);
			fputs("", gamelistfile);
			if (cpu3)
				fputs(cpu3, gamelistfile);
			fputs("", gamelistfile);
			if (cpu3_clock)
				fputs(cpu3_clock, gamelistfile);
			fputs("", gamelistfile);
			if (cpu4)
				fputs(cpu4, gamelistfile);
			fputs("", gamelistfile);
			if (cpu4_clock)
				fputs(cpu4_clock, gamelistfile);
			fputs("", gamelistfile);
			if (sound1)
				fputs(sound1, gamelistfile);
			fputs("", gamelistfile);
			if (sound1_clock)
				fputs(sound1_clock, gamelistfile);
			fputs("", gamelistfile);
			if (sound2)
				fputs(sound2, gamelistfile);
			fputs("", gamelistfile);
			if (sound2_clock)
				fputs(sound2_clock, gamelistfile);
			fputs("", gamelistfile);
			if (sound3)
				fputs(sound3, gamelistfile);
			fputs("", gamelistfile);
			if (sound3_clock)
				fputs(sound3_clock, gamelistfile);
			fputs("", gamelistfile);
			if (sound4)
				fputs(sound4, gamelistfile);
			fputs("", gamelistfile);
			if (sound4_clock)
				fputs(sound4_clock, gamelistfile);
			fputs("", gamelistfile);

			/* same to extract different info from input field */
			tmp_array = g_strsplit(input, " ", 0);
			tmp_counter = 0;
			while ((tmp_array[tmp_counter + 1] != NULL)) {
				if (!strcmp
				    (tmp_array[tmp_counter], "players"))
					g_snprintf(num_players,
						MAX_ROMNAME,tmp_array[tmp_counter + 1]);
				if (!strcmp
				    (tmp_array[tmp_counter], "control"))
					g_snprintf(control,
						MAX_CONTROL,tmp_array[tmp_counter + 1]);
				if (!strcmp
				    (tmp_array[tmp_counter], "buttons"))
					g_snprintf(num_buttons,
						MAX_ROMNAME,tmp_array[tmp_counter + 1]);
				tmp_counter++;
			}
			g_strfreev(tmp_array);

			/* and write it in the file*/
			if (num_players)
				fputs(num_players, gamelistfile);
			fputs("", gamelistfile);
			if (strlen(num_buttons))
				fputs(num_buttons, gamelistfile);
/* zero button ?? maybe could find something else empty string could be fine also*/
			else
				fputs("0", gamelistfile);
			fputs("", gamelistfile);
			if (control)
				fputs(control, gamelistfile);
			fputs("", gamelistfile);
			
			/* here we have the video section 
			video ( screen *** orientation *** x *** y *** aspectx * aspecty * freq *** ) */
			/* Vector or raster 
			   vector games dont have resolution */
 			tmp_array = g_strsplit(video, " ", 0);
			if (!strcmp(tmp_array[2], "vector")) {
				/* vector  x resolution  y resolution */
				fputs("true00", gamelistfile);
				/* Frequence */
				fputs(tmp_array[10], gamelistfile);
				fputs("", gamelistfile);
			} else {
				fputs("false", gamelistfile);
				/* x resolution */
				fputs(tmp_array[6], gamelistfile);
				fputs("", gamelistfile);
				/* y resolution */
				fputs(tmp_array[8], gamelistfile);
				fputs("", gamelistfile);
				/* Frequence */
				fputs(tmp_array[14], gamelistfile);
				fputs("", gamelistfile);
			}
			
			/* Orientation */
			fputs(tmp_array[4], gamelistfile);
			fputs("", gamelistfile);
			
			g_strfreev(tmp_array);
		
			fputs(channels, gamelistfile);
			
			fputs("", gamelistfile);
			g_snprintf(value,100,"%i",nb_roms);
			fputs(value, gamelistfile);

			fputs("", gamelistfile);
			g_snprintf(value,100,"%i",nb_samples);
			fputs(value, gamelistfile);

			fputs("", gamelistfile);
			fputs(sampleof, gamelistfile);

			fputs("\n", gamelistfile);

			done_roms++;
			done = (gfloat) ((gfloat) (done_roms) /
					 (gfloat) (supported_games));
//			g_message("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%6.2f%%",done * 100 );
			update_loading_progress_window(done,gamename);
			while (gtk_events_pending()) gtk_main_iteration();
		}
	}
	
	pclose(xmame_pipe);
	
	g_free(romname);
	g_free(gamename);
	g_free(year);
	g_free(manu);
	g_free(cloneof);
	g_free(romof);
	g_free(sampleof);
	g_free(input);
	g_free(video);
	g_free(status);
	g_free(cpu1);
	g_free(cpu2);
	g_free(cpu3);
	g_free(cpu4);
	g_free(sound1);
	g_free(sound2);
	g_free(sound3);
	g_free(sound4);
	g_free(control);
	
	g_hash_table_foreach (driver_htable, (GHFunc)g_free, NULL);
	g_hash_table_destroy(driver_htable);
	
	tmp_counter = 0;
	while ((chip[tmp_counter] != NULL)) {
		g_free(chip[tmp_counter]);
		tmp_counter++;
	}
	g_free(driver_status);
                

	fclose(gamelistfile);
	g_free(filename);
	
	gtk_widget_destroy(progress_window);
	return TRUE;
}

gboolean get_mame_version(guint target_to_check)
{
	FILE *xmame_pipe=NULL;
	gchar *opt, *p;
	gchar line[BUFFER_SIZE];
//	gchar **version;
	gchar *tmp_xmame_target,*tmp_xmame_version;
	
        opt=g_strdup_printf("%s -version 2>/dev/null",mame_executable); 
	xmame_pipe = popen(opt, "r");
        g_free(opt);
	
	fgets(line, BUFFER_SIZE, xmame_pipe);
	for(p=line;(*p && (*p != '('));p++);
	*--p='\0';
	tmp_xmame_target = p = p+2;
	for(;(*p && (*p != ')'));p++);
	*p='\0';tmp_xmame_version= p = p+2;
	for(;(*p && (*p != '\n'));p++);
	*p='\0';
	gxmame_debug("checking xmame version: %s",line);
	if (target_to_check == EXECUTABLE)
	{
		g_free (executable_version.name);
		g_free (executable_version.target);
		g_free (executable_version.version);
		executable_version.name = g_strdup(line);
		executable_version.target = g_strdup(tmp_xmame_target);
		executable_version.version = g_strdup(tmp_xmame_version);
	}
	else
	{
		g_free (list_version.name);
		g_free (list_version.target);
		g_free (list_version.version);
		list_version.name = g_strdup(line);
		list_version.target = g_strdup(tmp_xmame_target);
		list_version.version = g_strdup(tmp_xmame_version);
	}
	mame_exe_version = g_strdup(line);

	gxmame_debug("name=%s. target=%s. version=%s.",
			executable_version.name,
			executable_version.target,
			executable_version.version);
	
	
	pclose(xmame_pipe);
	return TRUE;
}		
